# SwapWithVictim release 4 by David Bowland
# ./addons/eventscripts/swapwithvictim/swapwithvictim.py

# >>> To configure this addon please see swapwithvictim.cfg <<<

"""
Allows players to swap money, score, position, or team with their victims. Requires only ES 2.0+
"""


import es
import gamethread
import langlib
import os.path
import playerlib
import random


info = es.AddonInfo()
info.name = 'SwapWithVictim'
info.version = '4'
info.url = 'http://addons.eventscripts.com/addons/view/swapwithvictim'
info.basename = 'swapwithvictim'
info.author = 'SuperDave'


int_round_over = 0
dict_original_teams = {}
dict_swap_types = {'money':{}, 'position':{}, 'score':{}, 'team':{}}

tuple_tags = ('#all', '#primary', '#rifle', '#shotgun', '#smg', '#sniper', '#secondary', '#pistol', '#all_headshot', '#primary_headshot', '#rifle_headshot', '#shotgun_headshot', '#smg_headshot', '#sniper_headshot', '#secondary_headshot', '#pistol_headshot')
dict_weapons = {'deagle':['#all', '#secondary', '#pistol'], 'ak47':['#all', '#primary', '#rifle'], 'scout':['#all', '#primary', '#rifle', '#sniper'], 'aug':['#all', '#primary', '#rifle'], 'g3sg1':['#all', '#primary', '#rifle', '#sniper'], 'galil':['#all', '#primary', '#rifle'], 'famas':['#all', '#primary', '#rifle'], 'm4a1':['#all', '#primary', '#rifle'], 'sg552':['#all', '#primary', '#rifle'], 'sg550':['#all', '#primary', '#rifle', '#sniper'], 'm249':['#all', '#primary'], 'awp':['#all', '#primary', '#rifle', '#sniper'], 'tmp':['#all', '#primary', '#smg'], 'mp5navy':['#all', '#primary', '#smg'], 'glock':['#all', '#secondary', '#pistol'], 'elite':['#all', '#secondary', '#pistol'], 'm3':['#all', '#primary', '#shotgun'], 'xm1014':['#all', '#primary', '#shotgun'], 'usp':['#all', '#secondary', '#pistol'], 'mac10':['#all', '#primary', '#smg'], 'ump45':['#all', '#primary', '#smg'], 'p228':['#all', '#secondary', '#pistol'], 'fiveseven':['#all', '#secondary', '#pistol'], 'p90':['#all', '#primary', '#smg'], 'deagle_headshot':['#all', '#all_headshot', '#secondary', '#secondary_headshot', '#pistol', '#pistol_headshot'], 'ak47_headshot':['#all', '#all_headshot', '#primary', '#primary_headshot', '#rifle', '#rifle_headshot'], 'scout_headshot':['#all', '#all_headshot', '#primary', '#primary_headshot', '#rifle', '#rifle_headshot', '#sniper', '#sniper_headshot'], 'aug_headshot':['#all', '#all_headshot', '#primary', '#primary_headshot', '#rifle', '#rifle_headshot'], 'g3sg1_headshot':['#all', '#all_headshot', '#primary', '#primary_headshot', '#rifle', '#rifle_headshot', '#sniper', '#sniper_headshot'], 'galil_headshot':['#all', '#all_headshot', '#primary', '#primary_headshot', '#rifle', '#rifle_headshot'], 'famas_headshot':['#all', '#all_headshot', '#primary', '#primary_headshot', '#rifle', '#rifle_headshot'], 'm4a1_headshot':['#all', '#all_headshot', '#primary', '#primary_headshot', '#rifle', '#rifle_headshot'], 'sg552_headshot':['#all', '#all_headshot', '#primary', '#primary_headshot', '#rifle', '#rifle_headshot'], 'sg550_headshot':['#all', '#all_headshot', '#primary', '#primary_headshot', '#rifle', '#rifle_headshot', '#sniper', '#sniper_headshot'], 'm249_headshot':['#all', '#all_headshot', '#primary', '#primary_headshot'], 'awp_headshot':['#all', '#all_headshot', '#primary', '#primary_headshot', '#rifle', '#rifle_headshot', '#sniper', '#sniper_headshot'], 'tmp_headshot':['#all', '#all_headshot', '#primary', '#primary_headshot', '#smg', '#smg_headshot'], 'mp5navy_headshot':['#all', '#all_headshot', '#primary', '#primary_headshot', '#smg', '#smg_headshot'], 'glock_headshot':['#all', '#all_headshot', '#secondary', '#secondary_headshot', '#pistol', '#pistol_headshot'], 'elite_headshot':['#all', '#all_headshot', '#secondary', '#secondary_headshot', '#pistol', '#pistol_headshot'], 'm3_headshot':['#all', '#all_headshot', '#primary', '#primary_headshot', '#shotgun', '#shotgun_headshot'], 'xm1014_headshot':['#all', '#all_headshot', '#primary', '#primary_headshot', '#shotgun', '#shotgun_headshot'], 'usp_headshot':['#all', '#all_headshot', '#secondary', '#secondary_headshot', '#pistol', '#pistol_headshot'], 'mac10_headshot':['#all', '#all_headshot', '#primary', '#primary_headshot', '#smg', '#smg_headshot'], 'ump45_headshot':['#all', '#all_headshot', '#primary', '#primary_headshot', '#smg', '#smg_headshot'], 'p228_headshot':['#all', '#all_headshot', '#secondary', '#secondary_headshot', '#pistol', '#pistol_headshot'], 'fiveseven_headshot':['#all', '#all_headshot', '#secondary', '#secondary_headshot', '#pistol', '#pistol_headshot'], 'p90_headshot':['#all', '#all_headshot', '#primary', '#primary_headshot', '#smg', '#smg_headshot'], 'knife':['#all'], 'hegrenade':['#all'], 'other':['#all'], 'team':['#all'], 'team_suicide':['#all']}
dict_options = {'swapwithvictim_position_swapview':[1, '0 = no change, 1 = player swapping position will also swap view'], 'swapwithvictim_team_dropc4':[0, '0 = when a player with the C4 is swapped to the Counter-Terrorist team the C4 will be randomly given to a Terrorist, 1 = when a player with the C4 is swapped to the Counter-Terrorist team he or she will drop the C4'], 'swapwithvictim_team_sound':[50, 'Percent of the map that can heard the sound when a player changes teams--set to 0 for no sound'], 'swapwithvictim_announce_money_center':[2, '0 = no change, 1 = players receive a center text message when they swap money with their victim, 2 = players and victims receive a center text message when a player swaps money with his or her victim'], 'swapwithvictim_announce_money_chat':[3, '0 = no change, 1 = players receive a chat area message when they swap money with their victim, 2 = players and victims receive a chat area message when a player swaps money with his or her victim, 3 = all players receive a chat area message when a player swaps money with his or her victim'], 'swapwithvictim_announce_money_console':[0, '0 = no change, 1 = players receive a console message when they swap money with their victim, 2 = players and victims receive a console message when a player swaps money with his or her victim, 3 = all players receive a console message when a player swaps money with his or her victim'], 'swapwithvictim_announce_position_center':[1, '0 = no change, 1 = players receive a center text message when they swap position with their victim, 2 = players and victims receive a center text message when a player swaps position with his or her victim'], 'swapwithvictim_announce_position_chat':[3, '0 = no change, 1 = players receive a chat area message when they swap position with their victim, 2 = players and victims receive a chat area message when a player swaps position with his or her victim, 3 = all players receive a chat area message when a player swaps position with his or her victim'], 'swapwithvictim_announce_position_console':[0, '0 = no change, 1 = players receive a console message when they swap position with their victim, 2 = players and victims receive a console message when a player swaps position with his or her victim, 3 = all players receive a console message when a player swaps position with his or her victim'], 'swapwithvictim_announce_team_center':[0, '0 = no change, 1 = players receive a center text message when they swap teams with their victim, 2 = players and victims receive a center text message when a player swaps teams with his or her victim'], 'swapwithvictim_announce_team_chat':[0, '0 = no change, 1 = players receive a chat area message when they swap teams with their victim, 2 = players and victims receive a chat area message when a player swaps teams with his or her victim, 3 = all players receive a chat area message when a player swaps teams with his or her victim'], 'swapwithvictim_announce_team_console':[0, '0 = no change, 1 = players receive a console message when they swap teams with their victim, 2 = players and victims receive a console message when a player swaps teams with his or her victim, 3 = all players receive a console message when a player swaps teams with his or her victim'], 'swapwithvictim_announce_score_center':[2, '0 = no change, 1 = players receive a center text message when they swap scores with their victim, 2 = players and victims receive a center text message when a player swaps scores with his or her victim'], 'swapwithvictim_announce_score_chat':[3, '0 = no change, 1 = players receive a chat area message when they swap scores with their victim, 2 = players and victims receive a chat area message when a player swaps scores with his or her victim, 3 = all players receive a chat area message when a player swaps scores with his or her victim'], 'swapwithvictim_announce_score_console':[0, '0 = no change, 1 = players receive a console message when they swap scores with their victim, 2 = players and victims receive a console message when a player swaps scores with his or her victim, 3 = all players receive a console message when a player swaps scores with his or her victim'], 'swapwithvictim_announce_team_change_hud':[1, '0 = no change, 1 = players receive a HUD message when changing teams'], 'swapwithvictim_announce_team_change_center':[1, '0 = no change, 1 = players receive a center text message when changing teams'], 'swapwithvictim_announce_team_change_chat':[2, '0 = no change, 1 = players receive a chat area message when changing teams, 2 = all players receive a chat area message when a player changes teams'], 'swapwithvictim_announce_team_change_console':[0, '0 = no change, 1 = players receive a console message when changing teams, 2 = all players receive a console message when a player changes teams']}
func_lang_text = None


def load():
   """
   Checks to make sure critical server variables are created by the config
   Calls player_spawn for each player
   """
   global func_lang_text

   if not es.exists('command', 'swapwithvictim_add'):
      es.regcmd('swapwithvictim_add', 'swapwithvictim/option_cmd', 'swapwithvictim_add <money/position/score/team> <kill type> <percent chance of swap>\nServer command for specifying which kills trigger a swap')
   if not es.exists('command', 'swapwithvictim_remove'):
      es.regcmd('swapwithvictim_remove', 'swapwithvictim/option_cmd', 'swapwithvictim_remove <money/position/score/team> <kill type>\nServer command for removing kills specified to trigger a swap')

   for str_option in dict_options:
      es.ServerVar(str_option, dict_options[str_option][0], dict_options[str_option][1])
   if os.path.isfile(es.getAddonPath('swapwithvictim') + '/swapwithvictim.cfg'):
      es.server.cmd('es_xmexec ../addons/eventscripts/swapwithvictim/swapwithvictim.cfg')
   else:
      es.dbgmsg(0, 'SwapWithVictim: Unable to load swapwithvictim.cfg! Please ensure it is in the ./swapwithvictim/ directory.')
   str_lang_path = es.getAddonPath('swapwithvictim') + '/swapwithvictim_languages.ini'
   if os.path.isfile(str_lang_path):
      func_lang_text = langlib.Strings(str_lang_path)
   else:
      es.dbgmsg(0, 'SwapWithVictim: Unable to load swapwithvictim_languages.ini! Please ensure it is in the ./swapwithvictim/ directory.')
   if not func_lang_text:
      func_lang_text = missing_lang

   dict_player_list = es.createplayerlist()
   for int_userid in dict_player_list:
      player_spawn({'userid':str(int_userid), 'es_userteam':dict_player_list[int_userid]['teamid']})


def es_map_start(event_var):
   """Clears the dictionary of original teams"""
   global dict_original_teams

   dict_original_teams.clear()


def player_spawn(event_var):
   """Creates the player in dict_original_teams with the orignal team and model index"""
   global dict_original_teams

   int_userid = int(event_var['userid'])
   if not dict_original_teams.has_key(int_userid):
      dict_original_teams[int_userid] = {}
   dict_original_teams[int_userid]['team'] = int(event_var['es_userteam'])
   dict_original_teams[int_userid]['model'] = es.getplayerprop(int_userid, 'CBaseEntity.m_nModelIndex')


def player_death(event_var):
   """
   Determines the type of kill
   Calls the swap function and announces swap if necessary
   Calls set_original_teams if the victim was the last memebr of the team
   """
   str_weapon = event_var['weapon']
   int_userid = int(event_var['userid'])
   int_attackerid = int(event_var['attacker'])

   if event_var['es_userteam'] == event_var['es_attackerteam']:
      str_kill_type = 'team'
   elif int(event_var['headshot']) and dict_weapons.has_key(str_weapon + '_headshot'):
      str_kill_type = str_weapon + '_headshot'
   elif dict_weapons.has_key(str_weapon):
      str_kill_type = str_weapon
   else:
      str_kill_type = 'other'

   if int_userid <> int_attackerid and int_attackerid:
      dict_swap_functions = {'money':swap_money, 'position':swap_position, 'score':swap_score, 'team':swap_team}
      for str_swap_type in dict_swap_types:
         if dict_swap_types[str_swap_type].has_key(str_kill_type):
            if random.randint(1, 100) <= dict_swap_types[str_swap_type][str_kill_type]:
               if dict_swap_functions[str_swap_type](int_userid, int_attackerid):
                  announce_swap(int_userid, int_attackerid, str_swap_type)

   es.setplayerprop(int_userid, 'CBaseEntity.m_iTeamNum', dict_original_teams[int_userid]['team'])
   if not es.getlivingplayercount(event_var['es_userteam']):
      set_original_teams()


def player_disconnect(event_var):
   """Removes the disconnecting player from the dictionary"""
   global dict_original_teams

   int_userid = int(event_var['userid'])
   if dict_original_teams.has_key(int_userid):
      del dict_original_teams[int_userid]


def round_start(event_var):
   """Sets int_round_over to show the round is in progress"""
   global int_round_over

   int_round_over = 0


def round_end(event_var):
   """
   Sets int_round_over to show the round has ended
   Calls set_original_teams
   """
   global int_round_over

   int_round_over = 1

   set_original_teams()


def unload():
   """Calls set_original_teams"""
   set_original_teams()

   for str_option in dict_options:
      es.ServerVar(str_option).set(0)


def swap_money(int_userid, int_attackerid):
   """Swaps the money of the victim and attacker if the victim has more money"""

   int_return = 0
   int_money_user = es.getplayerprop(int_userid, 'CCSPlayer.m_iAccount')
   int_money_attacker = es.getplayerprop(int_attackerid, 'CCSPlayer.m_iAccount')
   if int_money_user > int_money_attacker:
      es.setplayerprop(int_userid, 'CCSPlayer.m_iAccount', int_money_attacker)
      es.setplayerprop(int_attackerid, 'CCSPlayer.m_iAccount', int_money_user)
      int_return = 1

   return int_return


def swap_position(int_userid, int_attackerid):
   """Moves the attacker to the victim's position"""

   if es.getplayerprop(int_attackerid, 'CBasePlayer.pl.deadflag'):
      return 0

   list_player_location = es.getplayerlocation(int_userid)
   es.server.cmd('es_xsetpos %s %s %s %s' % (int_attackerid, list_player_location[0], list_player_location[1], list_player_location[2]))
   if int(es.ServerVar('swapwithvictim_position_swapview')):
      es.server.cmd('es_xsetang %s %s %s 0' % (int_attackerid, es.getplayerprop(int_userid, 'CCSPlayer.m_angEyeAngles[0]'), es.getplayerprop(int_userid, 'CCSPlayer.m_angEyeAngles[1]')))

   return 1


def swap_score(int_userid, int_attackerid):
   """Swaps the scores of the victim and attacker if the victim has a higher score"""

   int_return = 0
   dict_player_list = es.createplayerlist()
   int_score_user = dict_player_list[int_userid]['kills']
   int_score_attacker = dict_player_list[int_attackerid]['kills']
   if int_score_user > int_score_attacker:
      dict_game_scores = es.createentitylist('game_score')
      int_game_score_index = es.getentityindex('game_score')
      if len(dict_game_scores) > 1:
         for int_index in dict_game_scores:
            if int_index <> int_game_score_index:
               es.server.cmd('es_xremove %s' % int_index)
      elif int_game_score_index == -1:
         es.server.cmd('es_xgive %s game_score' % int_userid)
      es.server.cmd('es_xfire %s game_score addoutput \"spawnflags 1\"' % int_userid)

      es.server.cmd('es_xfire %s game_score addoutput \"points %s\"' % (int_userid, int_score_attacker - int_score_user - 1))
      es.server.cmd('es_xfire %s game_score applyscore' % int_userid)

      es.server.cmd('es_xfire %s game_score addoutput \"points %s\"' % (int_attackerid, int_score_user - int_score_attacker + 1))
      es.server.cmd('es_xfire %s game_score applyscore' % int_attackerid)
      int_return = 1

   return int_return


def swap_team(int_userid, int_attackerid):
   """Changes the attacker to the victim's team and model"""
   if es.getplayerprop(int_attackerid, 'CBasePlayer.pl.deadflag') or int_round_over:
      return 0

   int_return = 0
   int_team = es.getplayerteam(int_userid)
   int_attacker_team = es.getplayerteam(int_attackerid)
   if int_team <> int_attacker_team:
      if es.getlivingplayercount(int_attacker_team) > 1:
         change_team(int_attackerid, int_team, es.getplayerprop(int_userid, 'CBaseEntity.m_nModelIndex'))
         int_return = 1
      else:
         set_original_teams()

   return int_return


def change_team(int_userid, int_team, int_model):
   """
   Changes the attacker to the team and model of the victim
   Handles the C4 if the attacker had the C4 and switched to the Counter-Terrorist team
   Plays a sound to alerts player of the team swap
   Announces the team swap
   """
   es.setplayerprop(int_userid, 'CBaseEntity.m_iTeamNum', int_team)
   int_defuser = es.getplayerprop(int_userid, 'CCSPlayer.m_bHasDefuser')
   es.setplayerprop(int_userid, 'CBaseEntity.m_nModelIndex', int_model)
   es.setplayerprop(int_userid, 'CCSPlayer.m_bHasDefuser', 0)
   gamethread.delayed(0.1, es.setplayerprop, (int_userid, 'CCSPlayer.m_bHasDefuser', int_defuser))

   int_player_handle = es.getplayerhandle(int_userid)
   int_c4_index = 0
   for int_index in es.createentitylist('weapon_c4'):
      if int_player_handle == es.getindexprop(int_index, 'CBaseEntity.m_hOwnerEntity'):
         int_c4_index = int_index
   if int_c4_index:
      int_drop_c4 = int(es.ServerVar('swapwithvictim_team_dropc4'))
      if not int_drop_c4:
         list_t_players = []
         for int_loop_userid in dict_original_teams:
            if es.getplayerteam(int_loop_userid) == 2 and not es.getplayerprop(int_loop_userid, 'CBasePlayer.pl.deadflag'):
               list_t_players.append(int_loop_userid)
         if list_t_players:
            es.server.cmd('es_xremove %s' % int_c4_index)
            es.server.cmd('es_xgive %s weapon_c4' % random.choice(list_t_players))
         else:
            int_drop_c4 = 1
      if int_drop_c4:
         es.sexec(int_userid, 'use weapon_c4')
         es.sexec(int_userid, 'drop')

   float_sound = float(es.ServerVar('swapwithvictim_team_sound'))
   if float_sound:
      es.emitsound('player', int_userid, 'items/nvg_on.wav', 1.0, (100 - float_sound) / 100)

   str_player_lang = playerlib.getPlayer(int_userid).get('lang')
   str_player_msg = 'player team %s' % int_team
   str_change_msg = 'team change %s' % int_team
   dict_tokens = {'player':es.getplayername(int_userid)}
   if int(es.ServerVar('swapwithvictim_announce_team_change_hud')):
      es.server.cmd('es_xfire %s env_hudhint kill' % int_userid)
      es.server.cmd('es_xgive %s env_hudhint' % int_userid)
      es.server.cmd('es_xfire %s env_hudhint addoutput \"message %s\"' % (int_userid, remove_tags(func_lang_text(str_player_msg, {}, str_player_lang))))
      es.server.cmd('es_xfire %s env_hudhint showhudhint' % int_userid)
   if int(es.ServerVar('swapwithvictim_announce_team_change_center')):
      es.centertell(int_userid, remove_tags(func_lang_text(str_player_msg, {}, str_player_lang)))
   int_option = int(es.ServerVar('swapwithvictim_announce_team_change_chat'))
   if int_option:
      es.tell(int_userid, '#multi', func_lang_text(str_player_msg, {}, str_player_lang))
      for int_loop_userid in dict_original_teams:
         if int_loop_userid <> int_userid:
            es.tell(int_loop_userid, '#multi', func_lang_text(str_change_msg, dict_tokens, playerlib.getPlayer(int_loop_userid).get('lang')))
   int_option = int(es.ServerVar('swapwithvictim_announce_team_change_console'))
   if int_option:
      es.cexec(int_userid, 'echo ' + remove_tags(func_lang_text(str_player_msg, {}, str_player_lang)))
      for int_loop_userid in dict_original_teams:
         if int_loop_userid <> int_userid:
            es.cexec(int_loop_userid, 'echo ' + remove_tags(func_lang_text(str_change_msg, dict_tokens, playerlib.getPlayer(int_loop_userid).get('lang'))))


def set_original_teams():
   """Sets all players back to original teams and models"""
   for int_userid in dict_original_teams:
      int_team = dict_original_teams[int_userid]['team']
      if not es.getplayerprop(int_userid, 'CBasePlayer.pl.deadflag') and int_team <> es.getplayerteam(int_userid):
         change_team(int_userid, int_team, dict_original_teams[int_userid]['model'])


def announce_swap(int_userid, int_attackerid, str_swap_type):
   """Announces when two players swap and the type of swap"""
   str_user_lang = playerlib.getPlayer(int_userid).get('lang')
   str_attacker_lang = playerlib.getPlayer(int_attackerid).get('lang')
   str_player_swap = 'swap ' + str_swap_type
   str_all_swap = 'swap %s all' % str_swap_type
   str_user_name = es.getplayername(int_userid)
   str_attacker_name = es.getplayername(int_attackerid)
   dict_tokens = {'attacker':str_attacker_name, 'victim':str_user_name}
   tuple_avoid = (int_userid, int_attackerid)

   int_option = int(es.ServerVar('swapwithvictim_announce_%s_center' % str_swap_type))
   if int_option:
      es.centertell(int_attackerid, remove_tags(func_lang_text(str_player_swap, {'player':str_user_name}, str_attacker_lang)))
      if int_option == 2:
         es.centertell(int_userid, remove_tags(func_lang_text(str_player_swap, {'player':str_attacker_name}, str_user_lang)))
   int_option = int(es.ServerVar('swapwithvictim_announce_%s_chat' % str_swap_type))
   if int_option:
      es.tell(int_attackerid, '#multi', func_lang_text(str_player_swap, {'player':str_user_name}, str_attacker_lang))
      if int_option >= 2:
         es.tell(int_userid, '#multi', func_lang_text(str_player_swap, {'player':str_attacker_name}, str_user_lang))
      if int_option == 3:
         for int_loop_userid in dict_original_teams:
            if int_loop_userid not in tuple_avoid:
               es.tell(int_loop_userid, '#multi', func_lang_text(str_all_swap, dict_tokens, playerlib.getPlayer(int_loop_userid).get('lang')))
   int_option = int(es.ServerVar('swapwithvictim_announce_%s_console' % str_swap_type))
   if int_option:
      es.cexec(int_attackerid, 'echo ' + remove_tags(func_lang_text(str_player_swap, {'player':str_user_name}, str_attacker_lang)))
      if int_option >= 2:
         es.cexec(int_userid, 'echo ' + remove_tags(func_lang_text(str_player_swap, {'player':str_attacker_name}, str_user_lang)))
      if int_option == 3:
         for int_loop_userid in dict_original_teams:
            if int_loop_userid not in tuple_avoid:
               es.cexec(int_loop_userid, 'echo ' + remove_tags(func_lang_text(str_all_swap, dict_tokens, playerlib.getPlayer(int_loop_userid).get('lang'))))


def option_cmd():
   """
   swapwithvictim_add <money/position/score/team> <kill type> <percent chance of swap>
   swapwithvictim_remove <money/position/score/team> <kill type>
   Sets the chace of swap on the desired weapon for the specified swap type
   """
   global dict_swap_types

   str_command = es.getargv(0).lower()
   if es.getargc() == {'swapwithvictim_add':4, 'swapwithvictim_remove':3}[str_command]:
      str_swap_type = es.getargv(1).lower()
      if dict_swap_types.has_key(str_swap_type):
         dict_current_swap = dict_swap_types[str_swap_type]

         str_weapon_tag = es.getargv(2).lower()
         if str_weapon_tag[0:7] == 'weapon_':
            str_weapon_tag = str_weapon_tag[7:]
         if str_command == 'swapwithvictim_add':
            int_percent = int(es.getargv(3))

         if str_weapon_tag in tuple_tags:
            if str_command == 'swapwithvictim_add':
               for str_weapon in dict_weapons:
                  if str_weapon_tag in dict_weapons[str_weapon]:
                     dict_current_swap[str_weapon] = int_percent
            else:
               for str_weapon in dict_weapons:
                  if str_weapon_tag in dict_weapons[str_weapon] and dict_current_swap.has_key(str_weapon):
                     del dict_current_swap[str_weapon]
         elif dict_weapons.has_key(str_weapon_tag):
            if str_command == 'swapwithvictim_add':
               dict_current_swap[str_weapon_tag] = int_percent
            elif dict_current_swap.has_key(str_weapon_tag):
               del dict_current_swap[str_weapon_tag]

         else:
            es.dbgmsg(0, 'SwapWithVictim: Unrecognized weapon or weapon type \"%s\"' % str_weapon_tag)
      else:
         es.dbgmsg(0, 'SwapWithVictim: Unrecognized swap type \"%s\"' % str_swap_type)
   else:
      es.dbgmsg(0, 'Syntax: ' + {'swapwithvictim_add':'swapwithvictim_add <money/position/score/team> <kill type> <percent chance of swap>', 'swapwithvictim_remove':'swapwithvictim_remove <money/position/score/team> <kill type>'}[str_command])


def remove_tags(str_text):
   """Removes #lightgreen, #green and #default tags from the supplied string"""
   return str_text.replace('#lightgreen', '').replace('#green', '').replace('#default', '')


def missing_lang(str_heading, dict_tokens, str_language):
   """Displays an error message because the languages .ini could not be found"""
   return 'SwapWithVictim: swapwithvictim_languages.ini not found'